diff --git a/Makefile.am b/Makefile.am
index 5a42bb90b2..e993552fe9 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -132,6 +132,14 @@ MODULES =					\
   guix/workers.scm				\
   guix/least-authority.scm			\
   guix/ipfs.scm					\
+  guix/platform.scm                             \
+  guix/platforms/arm.scm                        \
+  guix/platforms/hurd.scm                       \
+  guix/platforms/mips.scm                       \
+  guix/platforms/powerpc.scm                    \
+  guix/platforms/riscv.scm                      \
+  guix/platforms/s390.scm                       \
+  guix/platforms/x86.scm                        \
   guix/build-system.scm				\
   guix/build-system/android-ndk.scm		\
   guix/build-system/ant.scm			\
diff --git a/doc/guix.texi b/doc/guix.texi
index b960c546a8..d5b12005c4 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -40447,7 +40447,7 @@ guix build --target=armv5tel-linux-gnueabi bootstrap-tarballs
 @end example
 
 For this to work, it is first required to register a new platform as
-defined in the @code{(gnu platform)} module.  A platform is making the
+defined in the @code{(guix platform)} module.  A platform is making the
 connection between a GNU triplet (@pxref{Specifying Target Triplets, GNU
 configuration triplets,, autoconf, Autoconf}), the equivalent
 @var{system} in Nix notation, the name of the
diff --git a/etc/release-manifest.scm b/etc/release-manifest.scm
index 1098f491ba..dd70068490 100644
--- a/etc/release-manifest.scm
+++ b/etc/release-manifest.scm
@@ -23,7 +23,7 @@
 (use-modules (gnu packages)
              (guix packages)
              (guix profiles)
-             ((gnu platform) #:select (targets))
+             ((guix platform) #:select (targets))
              ((gnu services xorg) #:select (%default-xorg-modules))
              (guix utils)
              (srfi srfi-1)
diff --git a/gnu/ci.scm b/gnu/ci.scm
index 00f9d56003..bd36300ba9 100644
--- a/gnu/ci.scm
+++ b/gnu/ci.scm
@@ -54,7 +54,7 @@ (define-module (gnu ci)
   #:use-module (gnu packages multiprecision)
   #:use-module (gnu packages make-bootstrap)
   #:use-module (gnu packages package-management)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (gnu system)
   #:use-module (gnu system image)
   #:use-module (gnu system vm)
diff --git a/gnu/image.scm b/gnu/image.scm
index 0b3a5a096b..e10a495d3d 100644
--- a/gnu/image.scm
+++ b/gnu/image.scm
@@ -17,7 +17,7 @@
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
 (define-module (gnu image)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (partition
             partition?
diff --git a/gnu/local.mk b/gnu/local.mk
index 2a74677509..b6592586b7 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -89,7 +89,6 @@ GNU_SYSTEM_MODULES =				\
   %D%/home/services/utils.scm			\
   %D%/home/services/xdg.scm			\
   %D%/image.scm					\
-  %D%/platform.scm				\
   %D%/packages.scm				\
   %D%/packages/abduco.scm			\
   %D%/packages/abiword.scm			\
@@ -631,13 +630,6 @@ GNU_SYSTEM_MODULES =				\
   %D%/packages/zile.scm				\
   %D%/packages/zwave.scm			\
 						\
-  %D%/platforms/arm.scm		                \
-  %D%/platforms/mips.scm	                \
-  %D%/platforms/powerpc.scm	                \
-  %D%/platforms/riscv.scm	                \
-  %D%/platforms/s390.scm	                \
-  %D%/platforms/x86.scm		                \
-						\
   %D%/services.scm				\
   %D%/services/admin.scm			\
   %D%/services/audio.scm                        \
diff --git a/gnu/packages/bioinformatics.scm b/gnu/packages/bioinformatics.scm
index 2a312b1989..474d85f320 100644
--- a/gnu/packages/bioinformatics.scm
+++ b/gnu/packages/bioinformatics.scm
@@ -161,7 +161,7 @@ (define-module (gnu packages bioinformatics)
   #:use-module (gnu packages wget)
   #:use-module (gnu packages xml)
   #:use-module (gnu packages xorg)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (srfi srfi-1)
   #:use-module (srfi srfi-26)
   #:use-module (ice-9 match))
diff --git a/gnu/packages/bootstrap.scm b/gnu/packages/bootstrap.scm
index 5337617a53..d2914fb5a7 100644
--- a/gnu/packages/bootstrap.scm
+++ b/gnu/packages/bootstrap.scm
@@ -26,7 +26,7 @@
 (define-module (gnu packages bootstrap)
   #:use-module (guix licenses)
   #:use-module (gnu packages)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (guix packages)
   #:use-module (guix download)
   #:use-module (guix build-system)
diff --git a/gnu/packages/cross-base.scm b/gnu/packages/cross-base.scm
index 427fefbcd2..93e4f8a445 100644
--- a/gnu/packages/cross-base.scm
+++ b/gnu/packages/cross-base.scm
@@ -30,7 +30,7 @@ (define-module (gnu packages cross-base)
   #:use-module (gnu packages linux)
   #:use-module (gnu packages hurd)
   #:use-module (gnu packages mingw)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (guix packages)
   #:use-module (guix download)
   #:use-module (guix utils)
diff --git a/gnu/packages/instrumentation.scm b/gnu/packages/instrumentation.scm
index c5062388f8..2db21aef1b 100644
--- a/gnu/packages/instrumentation.scm
+++ b/gnu/packages/instrumentation.scm
@@ -42,7 +42,7 @@ (define-module (gnu packages instrumentation)
   #:use-module (gnu packages swig)
   #:use-module (gnu packages tbb)
   #:use-module (gnu packages xml)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (guix build-system cmake)
   #:use-module (guix build-system copy)
   #:use-module (guix build-system gnu)
diff --git a/gnu/packages/linux.scm b/gnu/packages/linux.scm
index e3a37a7698..95a9bbe39f 100644
--- a/gnu/packages/linux.scm
+++ b/gnu/packages/linux.scm
@@ -158,7 +158,7 @@ (define-module (gnu packages linux)
   #:use-module (gnu packages groff)
   #:use-module (gnu packages selinux)
   #:use-module (gnu packages swig)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (guix build-system cmake)
   #:use-module (guix build-system copy)
   #:use-module (guix build-system gnu)
diff --git a/gnu/system/image.scm b/gnu/system/image.scm
index 74b81d02f6..dd32e58c2d 100644
--- a/gnu/system/image.scm
+++ b/gnu/system/image.scm
@@ -32,7 +32,7 @@ (define-module (gnu system image)
   #:use-module (gnu bootloader)
   #:use-module (gnu bootloader grub)
   #:use-module (gnu image)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (gnu services)
   #:use-module (gnu services base)
   #:use-module (gnu system)
diff --git a/gnu/system/images/hurd.scm b/gnu/system/images/hurd.scm
index 4c38c46a89..36b6f3a200 100644
--- a/gnu/system/images/hurd.scm
+++ b/gnu/system/images/hurd.scm
@@ -23,7 +23,7 @@ (define-module (gnu system images hurd)
   #:use-module (gnu bootloader grub)
   #:use-module (gnu image)
   #:use-module (gnu packages ssh)
-  #:use-module (gnu platforms hurd)
+  #:use-module (guix platforms hurd)
   #:use-module (gnu services)
   #:use-module (gnu services ssh)
   #:use-module (gnu system)
diff --git a/gnu/system/images/novena.scm b/gnu/system/images/novena.scm
index 5b625e56c5..b9ff6dcfea 100644
--- a/gnu/system/images/novena.scm
+++ b/gnu/system/images/novena.scm
@@ -22,7 +22,7 @@ (define-module (gnu system images novena)
   #:use-module (gnu bootloader u-boot)
   #:use-module (gnu image)
   #:use-module (gnu packages linux)
-  #:use-module (gnu platforms arm)
+  #:use-module (guix platforms arm)
   #:use-module (gnu services)
   #:use-module (gnu services base)
   #:use-module (gnu system)
diff --git a/gnu/system/images/pine64.scm b/gnu/system/images/pine64.scm
index aaec458766..99c4ed6ceb 100644
--- a/gnu/system/images/pine64.scm
+++ b/gnu/system/images/pine64.scm
@@ -21,7 +21,7 @@ (define-module (gnu system images pine64)
   #:use-module (gnu bootloader u-boot)
   #:use-module (gnu image)
   #:use-module (gnu packages linux)
-  #:use-module (gnu platforms arm)
+  #:use-module (guix platforms arm)
   #:use-module (gnu services)
   #:use-module (gnu services base)
   #:use-module (gnu system)
diff --git a/gnu/system/images/pinebook-pro.scm b/gnu/system/images/pinebook-pro.scm
index 1bfac7a8bb..7e8910427e 100644
--- a/gnu/system/images/pinebook-pro.scm
+++ b/gnu/system/images/pinebook-pro.scm
@@ -21,7 +21,7 @@ (define-module (gnu system images pinebook-pro)
   #:use-module (gnu bootloader u-boot)
   #:use-module (gnu image)
   #:use-module (gnu packages linux)
-  #:use-module (gnu platforms arm)
+  #:use-module (guix platforms arm)
   #:use-module (gnu services)
   #:use-module (gnu services base)
   #:use-module (gnu system)
diff --git a/gnu/system/images/rock64.scm b/gnu/system/images/rock64.scm
index d25d55e528..68cb65f115 100644
--- a/gnu/system/images/rock64.scm
+++ b/gnu/system/images/rock64.scm
@@ -21,7 +21,7 @@ (define-module (gnu system images rock64)
   #:use-module (gnu bootloader u-boot)
   #:use-module (gnu image)
   #:use-module (gnu packages linux)
-  #:use-module (gnu platforms arm)
+  #:use-module (guix platforms arm)
   #:use-module (gnu services)
   #:use-module (gnu services base)
   #:use-module (gnu services networking)
diff --git a/gnu/platform.scm b/guix/platform.scm
similarity index 98%
rename from gnu/platform.scm
rename to guix/platform.scm
index fdc3685e7c..361241cb2e 100644
--- a/gnu/platform.scm
+++ b/guix/platform.scm
@@ -16,7 +16,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platform)
+(define-module (guix platform)
   #:use-module (guix discovery)
   #:use-module (guix memoization)
   #:use-module (guix records)
@@ -78,7 +78,7 @@ (define-record-type* <platform> platform make-platform
 (define (platform-modules)
   "Return the list of platform modules."
   (all-modules (map (lambda (entry)
-                      `(,entry . "gnu/platforms"))
+                      `(,entry . "guix/platforms"))
                     %load-path)
                #:warn warn-about-load-error))
 
diff --git a/gnu/platforms/arm.scm b/guix/platforms/arm.scm
similarity index 92%
rename from gnu/platforms/arm.scm
rename to guix/platforms/arm.scm
index bf68b2d00f..32c0fbc032 100644
--- a/gnu/platforms/arm.scm
+++ b/guix/platforms/arm.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms arm)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms arm)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (armv7-linux
             aarch64-linux))
diff --git a/gnu/platforms/hurd.scm b/guix/platforms/hurd.scm
similarity index 90%
rename from gnu/platforms/hurd.scm
rename to guix/platforms/hurd.scm
index 328e9818ad..baa6c23b41 100644
--- a/gnu/platforms/hurd.scm
+++ b/guix/platforms/hurd.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms hurd)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms hurd)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (hurd))
 
diff --git a/gnu/platforms/mips.scm b/guix/platforms/mips.scm
similarity index 90%
rename from gnu/platforms/mips.scm
rename to guix/platforms/mips.scm
index 174657da13..e6fa9eb292 100644
--- a/gnu/platforms/mips.scm
+++ b/guix/platforms/mips.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms mips)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms mips)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (mips64-linux))
 
diff --git a/gnu/platforms/powerpc.scm b/guix/platforms/powerpc.scm
similarity index 92%
rename from gnu/platforms/powerpc.scm
rename to guix/platforms/powerpc.scm
index 1d0b5cb666..9d0b343bc3 100644
--- a/gnu/platforms/powerpc.scm
+++ b/guix/platforms/powerpc.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms powerpc)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms powerpc)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (powerpc-linux
             powerpc64le-linux))
diff --git a/gnu/platforms/riscv.scm b/guix/platforms/riscv.scm
similarity index 91%
rename from gnu/platforms/riscv.scm
rename to guix/platforms/riscv.scm
index c2b4850e55..c716c12c12 100644
--- a/gnu/platforms/riscv.scm
+++ b/guix/platforms/riscv.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms riscv)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms riscv)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (riscv64-linux))
 
diff --git a/gnu/platforms/s390.scm b/guix/platforms/s390.scm
similarity index 90%
rename from gnu/platforms/s390.scm
rename to guix/platforms/s390.scm
index d3b1133974..b5477f1e5e 100644
--- a/gnu/platforms/s390.scm
+++ b/guix/platforms/s390.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms s390)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms s390)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (s390x-linux))
 
diff --git a/gnu/platforms/x86.scm b/guix/platforms/x86.scm
similarity index 94%
rename from gnu/platforms/x86.scm
rename to guix/platforms/x86.scm
index fba7dd4fc0..5338049d6f 100644
--- a/gnu/platforms/x86.scm
+++ b/guix/platforms/x86.scm
@@ -16,9 +16,8 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu platforms x86)
-  #:use-module (gnu platform)
-  #:use-module (gnu packages linux)
+(define-module (guix platforms x86)
+  #:use-module (guix platform)
   #:use-module (guix records)
   #:export (i686-linux
             x86_64-linux
diff --git a/guix/scripts/build.scm b/guix/scripts/build.scm
index 4383a399a0..75bbb701ae 100644
--- a/guix/scripts/build.scm
+++ b/guix/scripts/build.scm
@@ -48,7 +48,7 @@ (define-module (guix scripts build)
   #:use-module (srfi srfi-35)
   #:use-module (srfi srfi-37)
   #:use-module (gnu packages)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module ((guix status) #:select (with-status-verbosity))
   #:use-module ((guix progress) #:select (current-terminal-columns))
   #:use-module ((guix build syscalls) #:select (terminal-columns))
diff --git a/guix/scripts/system.scm b/guix/scripts/system.scm
index 73e3c299c1..eaa245eb44 100644
--- a/guix/scripts/system.scm
+++ b/guix/scripts/system.scm
@@ -66,7 +66,7 @@ (define-module (guix scripts system)
                  (device-module-aliases matching-modules)
   #:use-module (gnu system linux-initrd)
   #:use-module (gnu image)
-  #:use-module (gnu platform)
+  #:use-module (guix platform)
   #:use-module (gnu system)
   #:use-module (gnu bootloader)
   #:use-module (gnu system file-systems)
diff --git a/guix/self.scm b/guix/self.scm
index 9fff0ade04..9a64051c32 100644
--- a/guix/self.scm
+++ b/guix/self.scm
@@ -888,7 +888,7 @@ (define *system-modules*
                    ,@(scheme-modules* source "gnu/system")
                    ,@(scheme-modules* source "gnu/services")
                    ,@(scheme-modules* source "gnu/machine")
-                   ,@(scheme-modules* source "gnu/platforms/"))
+                   ,@(scheme-modules* source "guix/platforms/"))
                  (list *core-package-modules* *package-modules*
                        *extra-modules* *core-modules*)
                  #:extensions dependencies